#!/usr/bin/env python3
from urllib.request import urlretrieve
import sys

class Downloader():
    def download(self, urls, target_dir):
        for url in urls:
            filename=url.split("/")[-1]
            print(f"Downloading '#{url}'...", end="")
            try:
                urlretrieve(url, f"{target_dir}/{filename}")
                print("OK")
            except Exception as e:
                print(f"ERR ({e})")

class ImageDownloader(Downloader):
    def __init__(self,target_dir="images"):
        self.target_dir = target_dir
    def __str__(self):
        return f"The Image Downloader. We save to '{self.target_dir}'."
    def down(self, urls):
        super().download(urls,self.target_dir,)

if __name__ == "__main__":
    urls = sys.argv[1:]
    if len(urls)<1:
        exit("Usage: download.py <url> [<url2> ...]")
    dl = ImageDownloader()
    print(dl)
    dl.down(urls)
