#!/usr/bin/env python3
import sys
from urllib.request import urlretrieve


def download(urls, target_dir="down"):
    for url in urls:
        filename = url.split("/")[-1]
        print(f"Downloading '{url}'...", end="")
        try:
            urlretrieve(url, f"{target_dir}/{filename}")
            print("OK")
        except Exception as e:
            print(f"ERR ({e})")


if __name__ == "__main__":
    urls = sys.argv[1:]
    if len(urls) < 1:
        exit("Usage: download.py <url> [<url2> ...]")
    download(urls)
