#import "@preview/codelst:2.0.2": sourcecode
#import "@preview/pinit:0.2.2": *
#let now() = {
  set text (lang: "de")
  let today = datetime.today()
  return [#today.display("[month repr:long] [day padding:none], [year] ")]
}
#set page(footer: align(right,text(stroke:gray, size: 8pt,[Printed #now()])))
#show heading: set align(center)
#show raw: it => {
  show regex("pin\d+"): it => pin(eval(it.text.slice(3)))
  it
}

= Typical Python App (Object Oriented)
  #v(0.5cm)
  #sourcecode(raw(read("./code/oo.py")), lang: "Python" )

  #pagebreak()

= Typical Python App (Object Oriented)
  #v(0.5cm)
  #sourcecode(raw(read("./code/oo.py")), lang: "Python" )

=== Explanations:

#enum( spacing: 1cm, start: 5,
  [ // Line 5
    ```py
    pin1class Downloader()pin2:
    ```
    #pinit-highlight(1, 2)
    #pinit-point-from(2,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Object-oriented programming (OOP) with 'class' keyword.
    ]
    #v(0.5em)
  ],
  [ // Line 6
    ```py
    def download(pin3selfpin4, urls, target_dir):
    ```
    #pinit-highlight(3, 4)
    #pinit-point-from(3,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      First parameter is always 'self'
      (variable name 'self' is just a convention).
      With 'self' we point to the instance.
      E.g. to modify internal state.
    ]
    #v(1.8cm)
  ],
)

#enum( spacing: 1cm, start: 16,
  [ // Line 16
    ```py
    class ImageDownloader(pin10Downloaderpin11)
    ```
    #pinit-highlight(10, 11)
    #pinit-point-from(10,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Inheritance. Base class is 'Downloader'.
    ]
    #v(0.5em)
  ],
  [ // Line 17
    ```py
    def pin12__init__pin13(self,target_dir="images"):
    ```
    #pinit-highlight(12, 13)
    #pinit-point-from(12,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Constructor with 'dunder' (double underscore) method ```__init__```.
    ]
    #v(0.5em)
  ],
  [
    ...
  ],
  [ // Line 19
    ```py
    def pin14__str__pin15(self)
    ```
    #pinit-highlight(14, 15)
    #pinit-point-from(14,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      The toString method for pretty print.
    ]
    #v(0.5em)
  ],
  [
    ...
  ],
)

#enum( spacing: 1cm, start: 22,
  [ // Line 22
    ```py
    pin16super().downloadpin17(urls,self.target_dir,)
    ```
    #pinit-highlight(16, 17)
    #pinit-point-from(17,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Use 'super()' to access base clas .
    ]
    #v(0.5em)
  ],
)
