#import "@preview/codelst:2.0.2": sourcecode
#import "@preview/pinit:0.2.2": *
#let now() = {
  set text (lang: "de")
  let today = datetime.today()
  return [#today.display("[month repr:long] [day padding:none], [year] ")]
}
#set page(footer: align(right,text(stroke:gray, size: 8pt,[Printed #now()])))
#show heading: set align(center)
#show raw: it => {
  show regex("pin\d+"): it => pin(eval(it.text.slice(3)))
  it
}


= A Typical Python Skript
  #v(0.5cm)
  #sourcecode(raw(read("./code/suggested.py")), lang: "Python" )




#pagebreak()

= A Typical Python Skript
  #v(0.5cm)
  #sourcecode(raw(read("./code/suggested.py")), lang: "Python" )
  // #sourcecode(```
  //   #!/usr/bin/env python3
  //   from urllib.request import urlretrieve
  //   import sys

  //   def download(urls, target_dir="down"):
  //     for url in urls:
  //       filename=url.split("/")[-1]
  //       print(f"Downloading '{url}'...", end="")
  //       try:
  //           urlretrieve(url, f"{target_dir}/{filename}")
  //           print("OK")
  //       except Exception as e:
  //           print(f"ERR ({e})")

  //   if __name__ == "__main__":
  //       urls = sys.argv[1:]
  //       if len(urls)<1:
  //           exit("Usage: download.py <url> [<url2> ...]")
  //       download(urls)
  //   ```, lang: "Python" )

=== Explanations:

#enum( spacing: 1cm,
  [ // Line 1
    ```py
    pin1#!pin2/usr/bin/env python3
    ```
    #pinit-highlight(1, 2)
    #pinit-point-from(2,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      \#! Hash Bang: tell bash which binary to start
    ]
  ],
  [ // Line 2
    ```py
    from urllib.request pin3importpin4 urlretrieve
    ```
    #pinit-highlight(3, 4)
    #pinit-point-from(4,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Imports (optionally using 'from' for shorter names)
    ]
  ],
  [ // Line 3
    ```py
    import pin31syspin32
    ```
    #pinit-highlight(31, 32)
    #pinit-point-from(32,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Usage needs full namespace. For example in line 16 'sys.argv'.
    ]
  ],
  [...]
)
#enum( spacing: 1cm, start: 5,
  [ // Line 5
    ```py
    def download(urls, pin5target_dir="down"pin6):
    ```
    #pinit-highlight(5, 6)
    #pinit-point-from(6,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Default parameters
    ]
  ],
  [ // Line 6
    ```
    pin7  pin8pin9for url in urlspin10:
    ```
    #pinit-highlight(7, 8)
    #pinit-point-from(7,offset-dx: 0.5cm, offset-dy: 1.1cm, body-dy: -0.2cm)[
      Indentation with 4 spaces (better not tabs)
    ]
    #pinit-highlight(9, 10)
    #pinit-point-from(9,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      For element in list (i.e. foreach)
    ]#v(0.5cm)
  ],
  [ // Line 7
    ```
    filename=pin11url.split("/")[-1]pin12
    ```
    #pinit-highlight(11, 12)
    #pinit-point-from(12,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Split into list and get last element (index -1)
    ]
  ],
  [ // Line 8
    ```
    print(pin13f"Downloading '{url}'pin14...", pin15end=""pin16)
    ```
    #pinit-highlight(13, 14)
    #pinit-point-from(13,offset-dx: 0.5cm, offset-dy: 1.1cm, body-dy: -0.2cm)[
      Formatted string with {} to output expression.
    ]
    #pinit-highlight(15, 16)
    #pinit-point-from(16,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Optional parameter to suppress line break.
    ]
  ],
  [... ]
)
#enum( spacing: 1cm, start: 15,
  [ // Line 15
    ```py
    if pin17__name__ == "__main__"pin18:
    ```
    #pinit-highlight(17, 18)
    #pinit-point-from(17,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Detect if this code is called
      directly as script and not indirect as library
      or for running test cases.
    ]#v(1.5cm)
  ],
  [ // Line 16
    ```py
    urls = sys.pin19argv[1:]pin20
    ```
    #pinit-highlight(19, 20)
    #pinit-point-from(20,offset-dx: 0.5cm, offset-dy: 0.5cm, body-dy: -0.2cm)[
      Here the part (slice) starting with the second element.
    ]
  ],
)
