# Python clients

See [downloader.py](./downloader.py)

### Get some data

* Try to inspect request/response useing the minimal Python server:

* run a minimal (fake) server

	```bash
	./speakyserver.py
	```

* Send some data to learn what info the **speakyserver** gets via GET/POST requests:

 	```bash
 	curl 'http://localhost:8000/ws/apiv3/user/admin/info?lang=en&log=true#page=9'
 	```

* Then, run the Python script and inspect JSON response as well as server log

	```bash
	./downloader.py
	```


### Get some static data (using curl)

Optionally, try to use a static Python server for your experiments:

* create demo data

	```bash
	# simulate server with data:
	mkdir -p demodata
	echo "Consider this info private and it should only be retrieved with server-authentication." > demodata/secure.txt
	```

* run a static one liner Python server

	```bash
	python3 -m http.server  -d demodata 8080
	```

* Use curl as client

 	```bash
 	curl 'htttp://127.0.0.1:8080/secure.txt?pwd=SuperSecurePwd'
 	```

* This should return:
  > TODO. Consider this info private and it should only be retrieved with server-authentication.
