#!/usr/bin/env python3
import sys
from pathlib import Path


def main():
    file = get_filename()
    data = read_file(file)

    sum = 0
    for line in data:
        stripped_line = line.strip()
        if is_valid(stripped_line):
            sum += eval(stripped_line)

    print(sum)


def is_valid(untrusted):
    allowed_chars = '0123456789+-*/()'
    for char in untrusted:
        if char not in allowed_chars:
            return False
    return True


def get_filename():
    if len(sys.argv) < 2:
        sys.exit(f"Usage: {sys.argv[0]} filename")

    filename = Path(sys.argv[1])

    if not filename.is_file():
        sys.exit(f"provided file '{filename}' does not exist!")

    return filename


def read_file(filename):
    with open(filename) as file:
        data = file.readlines()
    return data


main()
