[Home](../README.md)

# 1e Debugging


Key Takeaway: **Simple way to output state is print statements. Advanced way to inspect state of a program is to halt it and inspect any variable in the current scope.**


Overview:

* (0) First, find and discuss the selected problems in folder [0_detect](./0_detect/).

	What is the state of a specific variable during program run?
	
* (1) Then, try to repair code given in folder [1_improve](./1_improve).

	Is it important to format the output during a debugging session? 

* (2) Finally, check out possible solutions as shown in folder [2_solution](./2_solution/)

	Use a debugger to **step into / step over** statements. Set **breakpoints**. Add variables to **watch**. 


## Learnings:

* Debugging

	When we create a script/program, we often find ourself confronted with errors. Finding and resolving such errors could be difficulty. The way to identify the fix an error is called debugging.

* Print debugging

	A simple way to debug our code - to check the state at some point - is simple to print out the contents of variables. It may be useful to *isolate* code segments by commenting out other parts, that are not necessary for the current check, or hardcode values temporarily. Important when doing so, don't forget to remove all (*unnecessary*) code and remove hardcoded parts afterwards!

* Using debugger

	A debugger is a tool that allows us to set **breakpoints** in our code and stop the execution of our program at this point. Then we can inspect the state of the program, try some temporary changes or simple run our code step by step and observe it's behavior.

	[Checkout Video](https://mode.fh-joanneum.at/-/static/vs_code_debugging.mp4)



## Outlook / further improvements: 

* With logging libraries it should be easy to configure the amount of output according to **debug level** given: *Info*, *Warning*, *Error*.
* Debugger can stop at **conditional breakpoints**, for example when a value reaches a given threshold (`counter > 7`). 