import sys

if len(sys.argv) != 2:
    sys.exit(f"usage: {sys.argv[0]} <Filter>")

filter = sys.argv[1]

with open("songtext.txt", "r", encoding="utf8") as file:
    song_text = file.read()
words = song_text.split()

clean_words = []
for word in words:
    word = word.strip("?").strip("!").strip(".").strip(",")
    if word.startswith(filter):
        clean_words.append(word)

word_count = {}
for word in clean_words:
    if word in word_count:
        word_count[word] += 1
    else:
        word_count[word] = 1


with open("songtext.csv", "w", encoding="utf8") as file:
    for idx, word in enumerate(dict(sorted(word_count.items(), key=lambda item: item[1], reverse=True)), 1):
        file.write(f"{idx},{word},{word_count[word]}\n")
