# This is a repo to demo minimal steps to use git


* Create project online.

	<https://mode.fh-joanneum.at/secure-code/learn-git/>
	
	
* Locally, on your machine create a ssh key pair. 


	```bash
	ssh-keygen -t rsa -b 4096 -C "corina@homeoffice"
	```

* For authentication, add your public ssh key to your user via the web.

	```bash
	cat ~/.ssh/id_rsa.pub
	```

	<https://mode.fh-joanneum.at/-/profile/keys>


* Clone

	```bash
	git clone git@mode.fh-joanneum.at:secure-code/learn-git/scivis.git
	```
	
* Exclude files and directories.

	```bash
	echo "TODO*" >> .gitignore
	echo "tmp" >> .gitignore
	```

* Add files (to _staging area_)

	```bash
	git add .
	```


* Modify files

* Check status

	```bash
	git status
	git diff
	git log
	```


* Write commit message (for all added/changed files)

	```bash
	git commit -am "Fixed typo in README.md"
	```


* Update from remote

	```bash
	git pull
	```


* Push (_staging area_) to remote repo

	```bash
	git push
	```
 