[Home](../README.md)

# 2a Managing Source Code


Key Takeaway: **Always backup, share and manage source code in (distributed) source code management systems, in git repositories!**


Overview:

* (0) First, find and discuss the selected problems in folder [0_detect](./0_detect/).

	What are the drawback of creating backups by file copy-and-rename?
	
* (1) Then, try to repair code given in folder [1_improve](./1_improve).

* (2) Finally, check out possible solutions as shown in folder [2_solution](./2_solution/)

	Learn, necessary steps to create a repository online, to clone it into local directory. Optionally, exclude files, such as configurations or other sensitive information, from git managment. 

## Learnings:

* Git `clone` into local directory. Use **ssh keys** to authenticate. 
* Get info about status with git `status`, `diff`, `log`.
* Add files and change files. Then use git `commit` to add a message.
* Update local copy with git `pull`, then update remote version with git `push`.

Plus:

* Ignore temporary or binary files with help of the `.gitignore` configuration file.
* Unwanted or unintended changes can be `stashed`. 

## Outlook / further improvements: 

* Check out how to creat a **feature branch** within a git repo.
* How to automate testing and deployment with git **pipelines**. 