[Home](../README.md)


# 2c Manage External Code and Dependencies

## Reusing foreign code

If you copy code, if you prompt ChatGPT for code, if you get code from Stackoverflow, please handle with care, it might be wrong or even corrupt!

Key Takeaway: **Copy and reuse only code you can understand 100%.**

## Virtual environments

Key Takeaway: **Use virtual environments when installing libraries. The installed libraries, the dependencies are independent of system libraries.**


Overview:

* (0) First, find and discuss the selected problems in folder [0_detect](./0_detect/).

	What are the drawback of installing libraries into the system?
	
* (1) Then, try to repair code given in folder [1_improve](./1_improve).

* (2) Finally, check out possible solutions as shown in folder [2_solution](./2_solution/)



## Learnings:

* Python **virtual environments** can be set up with modul *venv*: ```python3 -m venv .venv```. 
* Python virtual environments must be **activated** for use: execute ```./venv/bin/activate```.

## Outlook / further improvements: 

* If you need a custom configured operating system to run your programs, consider **Docker containers** or **Kubernetes pods**.