[Home](../README.md)

# 3b Consuming (GitLab) Webservices

Communication with a Server is today typically done in form of APIs, mostly a ReST-API.

ReST allows to use existing web technologies and mechanism (Request/Response) to operate in form of CRUD (**C**reate, **R**ead, **U**pdate, **D**elete) operations with a system.

Many (modern) platforms provide such API. In this example, we will take a short look on the API provided by GitLab.

Because we use basic web communication, we also can "simple" authenticate against such API. While in the end the API/service itself decides how someone can authenticate against it, GitLab only supports the usage of tokens, that a user have to create. Other services may also allow to use the username + password as used for login on the website itself.

But how could you know how to interact with an API? What endpoints are available, which arguments could be used and which authentication methods are allowed?

Modern - or better said **GOOD** - APIs provide typically a documentation on how they could be used. For example [GitLab](https://docs.gitlab.com/ee/api/rest/). There you will find an overview of how to use it, like which data could be asked, including examples.

Take for example the [`/projects`](https://docs.gitlab.com/ee/api/projects.html#list-all-projects) endpoint, where you can get an overview of _all_ projects that exist.

First, you need to use the correct HTTP method - to collect data typically **`GET`**.

```text
GET /projects
```

> `GET` is the default method communicating with webservers. When you enter an URL in your browser, a `GET` request will be done by it.

Additionally, GitLab provides a list of _optional_ Attributes, that could be used to filter the response. For example `search`, where you can enter a search string to search for specific projects.

| Attribute | Type | Required | Description |
| --------- | ---- | -------- | ----------- |
| `search`  | string | No | Return list of projects matching the search criteria. |

In the end, you have some http request, that you can send to the server. GitLab for example additionally provides some `cURL` examples inclusive example response.

```console
curl "https://mode.fh-joanneum.at/api/v4/projects?search=example"
```

> ReST APIs typically work with JSON data.
