#!/bin/bash

# Requirements: startup Flask server "imgapi" first (on port 5000)
# Here,
#   we expect you started the server with the hashed password for admin
#   username:    admin
#   password:    ThisIsAVery8ecureAndLongPa$$word!
#   sha256 hash: ac15ae65cac19d8d1fb17ef44c9f15ce0e459384a90e99bae9d7b33fb0d6beba

echo "***"
echo "* Simple demo calls with curl using username and password"
echo "***"

echo ""
echo "***"
echo "* Requesting ReSTful API via POST: /store (sending header info and passing imagename and imageformat)"
echo "***"
curl http://127.0.0.1:5000/store --data 'imagename=sunset&imageformat=png&password=ThisIsAVery8ecureAndLongPa$$word!&username=admin'

# Note: 
#     be aware of shell substitution, because $$ would mean "current shell process id" (pid) 
# => DO NOT USE  "" instead of '' 
# curl http://127.0.0.1:5000/store --data "imagename=sunset&imageformat=png&password=ThisIsAVery8ecureAndLongPa$$word!&username=admin"
