from flask import Flask, request
import hashlib
import re

# TODO: remove this, it is dangerous
#       maybe that is not the best idea, someone could reveal internal data, e.g. by sending
#       curl 'http://127.0.0.1:5000/calc?equation=sys.path'
import os


# The Image API server
img_api = Flask(__name__)

print(f"Using environmental configuration:")
img_api.config.from_prefixed_env()
admin_pwd_hash = img_api.config["IMGAPI"]["admin"]["passwordhash"]
user_token = img_api.config["IMGAPI"]["token"]


print(
    f" * : allow only access with admin pwd-hash '{admin_pwd_hash}'..."
)
print(
    f" * : or with token '{user_token}'..."
)


@img_api.route('/')
def welcome():
    # put application's code here
    return  """
This is a web service endpoint. Try to fetch data with curl. For example: 'curl http://127.0.0.1:5000/static/info.json'
"""

def sha256(plain: str):
    m = hashlib.sha256()
    m.update(plain.strip().encode('utf8'))
    return m.hexdigest()

def auth():
    # compare to existing token
    token = request.headers.get('authorization', False)
    if token and token.startswith('Bearer '):
        print(f"TOKEN: {token}")
        bearer = token.split(' ')[1]
        return bearer == user_token
    
    # string plain text pwd in memory -> pwd hash
    # compare to exiting hash
    username = request.form.get('username')
    #print(f"DBG: username: '{username}'.") # better not log/debug/output sensitive information
    password = request.form.get('password')
    #print(f"DBG: password: '{password}': '{sha256(password)}'.") # better not log/debug/output sensitive information
    print(f"DBG: HEADERS:: '{request.headers}'")

    if username and password:
        if username == 'admin' and sha256(password) == admin_pwd_hash:
            return True

    return False


# only POST when sending authentication data (via encrypted connection, via https)
@img_api.route('/store', methods=['POST'])
def add_image():
    if not auth():
        return "SORRY, you are not allowed to use this web service endpoint.", 403

    # TODO: deactivate DEBUG info output (especially usernames, tokens, passwords)
    print(f"DBG: HEADERS:: '{request.headers}'")
    host_name = request.headers.get('Host')
    client = request.headers.get('User-Agent')

    print(f"DBG: REQ: '{request.values}'")
    image_name = request.form.get('imagename', "dummy")
    image_format = request.form.get('imageformat', "png")

    if image_format not in ("png", "jpeg", "jpg", "gif"):
        return "SORRY, invalid imageformat", 400

    if not re.fullmatch(r'[a-z]+', image_name):
        return "SORRY, invalid imagename", 400

    print(
        f"DBG: SUCCESS, We store a new file on host '{host_name}' with name '{image_name}.{image_format}'...")

    return f"""SUCCESS ->
    A client ('{client}') sent '{image_name}.{image_format}' to be saved on the server '{host_name}'.\n"""


# DANGEROUS:
@img_api.route('/calc', methods=['POST', 'GET'])
def calculate():
    # TODO: NEVER allow exec, eval, os.system
    print(f"DBG: '{request.args}'")
    statement = request.args.get('equation', "0+0+0")
    print(f"DBG: we evaluate the given statement '{statement}': ")
    res = str(eval(statement))
    print(f"DBG: we evaluate the given statement '{statement}': '{res}'.")
    return res + "\n"


if __name__ == '__main__':
    img_api.run()
