[Home](../README.md)

# 3c Simple Server

* Example with Python - Flask Framework
  * See <https://flask.palletsprojects.com/>

## Selected Security Problems

### Attacks

* Info / attack on the system
  * fingerprinting, denial of service, ...
* Manipulation
  * Authentication bypass
  * Parameter Probing, data extraction/modification, ...

* Attack the system
  * remote command execution, privilege escalation

### Mitigation

* authentication / sessions
  * not just hiding resources, prevent path traversal
  * protect session token (e.g. timeout)

* Do **not trust** user input
  * User-input validation
  * User-input sanitization

* Resources (ReST-ful API URLs)
  * whitelisting

## Links

* Check API calls
  * structure, type and contents
  * see: <https://github.com/OAI/OpenAPI-Specification> (formally Swagger)
* Alternative servers
  * FastAPI: <https://fastapi.tiangolo.com>, <https://github.com/tiangolo/fastapi>

<!-- hacky example: curl 'http://localhost:5000/calc?equation=os.popen("cat%20%2fetc%2fpasswd").read()' -->