#!/usr/bin/env python3
# without library (optionally, use csv library ;)

# config
outfilename="umsatz-v2.csv"
SEPARATOR=';'

# prepare data
header = ["Produkt", "Kosten", "Anzahl", "Summe"] # Header
data = [
    ["Apfel", 1.2, 10],   # Row 1
    ["Birne", 1.4, 15],   # Row 2
    ["Kirsche", 2.5, 7],  # Row 3
]

# output
with open(outfilename,"w", encoding="utf-8") as f:

    # Optionally, we might output header names:
    f.write(SEPARATOR.join(header)+"\n")

    for row_elements in data:

        # we calc the 'sum' column
        # and we will add it to each row as a new column further down:
        product, prize, count = row_elements
        sum = prize * count

        # convert each of the four elements into a string
        #   Additionally, we convert float values to make Excel happy
        #       e.g. 1.2 to 1,2
        #   here: second and fourth column: price and sum
        row_elements = [
            str(product),
            str(prize).replace(".",","),
            str(count),
            str(sum).replace(".",",")
        ]

        # Output a single string with entries separated e.g. by ';'
        f.write(SEPARATOR.join(row_elements)+"\n")

print(f"Done. Find the data in '{outfilename}'.")
