from datetime import date
from openpyxl import load_workbook
# make sure openpyxl is installed! ('pip install openpyxl' or 'pip install -r requirements.txt')
# checkout setup.sh or setup.ps1

# load existing excel
wb = load_workbook("teilnehmer.xlsx")
# select existing/named worksheet
ws = wb["teilnahme"]

# open and load participant list
with open("teilgenommen.txt", "r") as file:
    participants = [line.strip().lower() for line in file.readlines()]

# select the next free column
col_index = 2
while ws.cell(1, col_index).value is not None:
    col_index += 1

# write the current date into the columns first row
ws.cell(1, col_index, date.today().strftime("%d.%m.%Y"))

# iterate over all rows and check if the name is
# part of the participants.
# when participation, than add "X" in the currents column row
for row in range(2, ws.max_row + 1):
    name = ws.cell(row, 1).value
    if name.lower() in participants:
        ws.cell(row, col_index, "X")

# save changes
wb.save("teilnehmer.xlsx")
