#!/bin/bash

# Script for MacOS and Linux (as well WSL on Windows and Git-Bash on Windows)!
# When using PowerShell on Windows, checkout setup.ps1

if [[ "${BASH_SOURCE[0]}" == "$0" ]]; then
  echo "please run me using 'source'... e.g.: source setup.sh"
  exit 1
fi

/usr/bin/env python3 -m venv .venv --prompt=pyexcel
ACTIVATE=""
if [ -d ".venv/bin" ]; then
  source .venv/bin/activate
  ACTIVATE="source .venv/bin/activate"
fi
if [ -d ".venv/Scripts" ]; then
  source .venv/Scripts/activate
  ACTIVATE="source .venv/Scripts/activate"
fi

pip install --upgrade pip
pip install -r requirements.txt
echo "----- SETUP FINISHED -----"
echo
echo "use '$ACTIVATE' on future sessions to re-activate the venv"
