[Home](../README.md)

# 3e Data Analytics: Data Visualisation


Key Takeaway: **Design your programme like a data flow through a pipeline.**

Overview:

* (0) First, find and discuss the selected problems in folder [0_detect](./0_detect/).

	How should we process large data sets? 

* (1) Then, try to repair code given in folder [1_improve](./1_improve).

	Discuss requirements and aims to find out which libraries could satisfy your needs. 

* (2) Finally, check out possible solutions as shown in folder [2_solution](./2_solution/)

	Use libraries, such as `numpy`, `pandas` to work with **data frames** and visualise with `seaborn` or `matplotlib`.

## Learnings:

* Data processing pipeline

* Step 1: Get (a large) data set. For example, check out existing (free available) data sets:
	* [Kaggle](https://www.kaggle.com/datasets)
	* [Wine Reviews](https://www.kaggle.com/datasets/zynicide/wine-reviews) 130k

* Step 2: Load and clean data

* Step 3: Perform calculations

* Step 4: Visualise 
	
	
## Links

Cheatsheets


* For data science libraries

	* Load and calculate with **numpy**: [Cheatsheet by Dataquest 2017](https://s3.amazonaws.com/dq-blog-files/numpy-cheat-sheet.pdf)

	* Data frames with **pandas**: [Cheatsheet by Pandas.org](https://pandas.pydata.org/Pandas_Cheat_Sheet.pdf), [by DataCamp](https://images.datacamp.com/image/upload/v1676302204/Marketing/Blog/Pandas_Cheat_Sheet.pdf)

* For visualisation libraries

	* Simple plots with **seaborn**: [Cheatsheet by DataCamp](https://images.datacamp.com/image/upload/v1676302629/Marketing/Blog/Seaborn_Cheat_Sheet.pdf)

	* Quick plotting with **matplotlib**: [Cheatsheets](https://matplotlib.org/cheatsheets/)   

	* Complex, but more beautiful plotting with **ggplot2**: [Cheatsheet by TidyVerse.org](https://ggplot2.tidyverse.org), [on GitHub](https://github.com/rstudio/cheatsheets/blob/main/data-visualization.pdf)


## Outlook / further improvements: 

* Use interactive data exploration tools. For example, try **Jupyter Notebooks**. 