#!/usr/bin/env python3
import sys
from os import makedirs
from urllib.request import urlretrieve

out_dir = "images"

print("Downloading images")
if len(sys.argv) < 2:
    sys.exit(f"\tUsage: {sys.argv.pop()} <file>.")


def custom_log(err):
    pass  # TODO


makedirs(out_dir, exist_ok=True)
with open(sys.argv[1]) as fh:
    urls = set(fh.readlines())
    for idx, url in enumerate(urls, start=1):
        url = url.strip()
        print(f"\t{idx}/{len(urls)} downloading '{url}'", end="...")
        suffix = url.split(".")[-1]
        try:
            urlretrieve(url, f"{out_dir}/image.{suffix}")
            print("OK")
        except Exception as err:
            print("NOT OK")
            custom_log(err)

print(f"Done. Find pictures in directory '{out_dir}'.")
