import re

input_lines = open(filename).readlines()  # lines, such as: "3+13" or "14*8"


# Note: only integer numbers and operators +, -, * are supported.
def extract_with_regex(input):
    calc_match = re.match(r"^(\d+\s*)([\*-+])\s*(\d+)$", input)  # see below
    if not calc_match:
        raise Exception("Unallowed input. Calculations + - * are supported")
    (left, op, right) = calc_match.groups()
    return int(left), op, int(right)


sum = 0
for idx, line in enumerate(input_lines, start=1):
    try:  # parsing might fail on erroneous input
        left, opr, right = extract_with_regex(line.strip())
    except Exception as err:
        print(f"\tSorry, unsure about '{line}', so we skip it. Err: '{err}'")
        continue
    if opr == "+":
        sum += left + right  # no eval/exec.. but explicit math operation
    # elif opr == "-": ...same for - and *
    else:
        print("WARN: Unexpected operator '{opr}'. Not implemented.")

print(f"Final result: Sum = {sum}.")
