#!/bin/bash

# Requirements: startup Flask server "imgapi" first (on port 5000)

echo "***"
echo "* Simple demo calls with curl."
echo "***"

echo ""
echo "***"
echo "* Requesting default HTML-Welcome page: /"
echo "***"
curl http://127.0.0.1:5000/

echo ""
echo "***"
echo "* Requesting static files via GET: /static/info.json"
echo "***"
curl http://127.0.0.1:5000/static/info.json

echo ""
echo "***"
echo "* Requesting ReSTful API via POST: /store (sending header info and passing imagename and imageformat)"
echo "***"
curl -H "Host: attacker" http://127.0.0.1:5000/store --data "imagename=sunset&imageformat=svg"


echo ""
echo "***"
echo "* Requesting ReSTful API via GET: /calc (get parameter 'equation=5-345')"
echo "***"
curl 'http://127.0.0.1:5000/calc?equation=5-345'

echo ""
echo "***"
echo "* EVIL (!) Requesting ReSTful API via GET: /calc (get parameter 'equation=sys.path')"
echo "***"
curl 'http://127.0.0.1:5000/calc?equation=sys.path'
# curl 'http://127.0.0.1:5000/calc?equation=dir(sys)'

# stop the server (-thread):
# curl 'http://127.0.0.1:5000/calc?equation=sys.stdin.readline()'