#!/usr/bin/env python3
from openpyxl import Workbook

wb = Workbook()
ws = wb.active
ws.title = "Umsatz"

# A1:D1
ws.append(["Produkt", "Preis", "Menge", "Gesamtpreis"])

data = [
    #   A      B    C
    ["Apfel", 1.2, 10],   # 2
    ["Birne", 1.4, 15],   # 3
    ["Kirsche", 2.5, 7],  # 4
]

for idx, row in enumerate(data, start=2):
    # append ads to the end... => column D
    row.append(f"=B{idx}*C{idx}") # e.g. '=B2*C2'
    # append current row to worksheet
    ws.append(row)

ws["D5"] = "=SUM(D2:D4)"

wb.save("umsatz.xlsx")
