#import "../style/template.typ": *

#let bestpractices( selected_lang: "en" ) = {

  if selected_lang == "en" [

  == Best Practices

  #markup([Problem], [
    Troubles reading code?
  ])

  - Solution A Naming and Semantics

  - Solution B Tell current state

  - Solution C Exit early. Avoid deep nesting.

  - Solution D Using

  ]else[

  == Empfehlungen

  #section_summary([
    Grundlegende Empfehlungen (#english_term([good practice])) für das Verfassen von Skripts zur Automatisierung von Abläufen: Sinnvolle Demo Daten, schrittweises Vorgehen, geringe Verschachtelungstiefe des Source Codes, sowie defensives Programmieren und mit fehlerhaftem Input rechnen.
  ])

  #markup([Problem], [
    Leider sind Programme manchmal wirklich schwer anzupassen und weiter zu verwenden.
    Wenn die Lesbarkeit mangelhaft ist, oder das Nachvollziehen des Algorithmus schwerfällt,
    dann getraut man sich nicht fremden Code zu ändern. Schlecht lesbarer Code und
    nichtssagende Fehlermeldungen machen keinen Spaß.
  ])


    #pysrc_with_overlay("1a/no.py", [Please Improve])

  - *Empfehlung A: Start mit "guten" Daten*.
    Das Generieren einer Liste von einigen "echten" Demodaten — also auch mit üblichen Fehlern und menschlichen Ungenauigkeiten — hilft beim Durchdenken des Lösungswegs.

    #textsrc("1a/urls.txt", title:"urls.txt")

  - *Empfehlung B: Schritt-für Schritt Umsetzung*.
    Man startet mit der Entwicklung des Ablaufes, des Algorithmus als Kommentar. Schrittweise können dann die Kommentare Zeile für Zeile durch echten Code ersetzt werden. Hilfreich ist das Skript möglichst oft — auch schon nach kleinen Änderungen — auszuführen, denn so treten jeweils nur wenige Fehler auf. Die auftretenden Fehler können auch leichter lokalisiert werden.

    #pysrc_with_ok("1a/from-comment-to-code.py")

  - *Empfehlung C: Tiefe Verschachtelung vermeiden* durch Prüfen der Voraussetzung und Eingangsdaten am Beginn jeder Funktion. Bei nicht behebbaren Fehlern sofortiges Beenden des Programmes. #english_term([Exit early])!

    #pysrc_with_ok("1a/exitearly-snippet.py")

  #pagebreak()

  - *Empfehlung D: Sichere Abläufe durch Fehlervermeidung*.
    Beispielsweise empfiehlt es sich einen #pykeyword([with]) Block zu verwenden umd Ressourcen automatisch zu schließen. #english_term([Defensive coding])!

    #pysrc_with_ok("1a/with-snippet.py")

  #v(0.5cm)

  *Weitere Empfehlungen:*

  - Für die Übersichtlichkeit und das Lesen ist das Aufteilen von Code auf mehrere Funktionen und auch auf mehrere Dateien nützlich.
  - Funktionen sollten nicht zu lang sein. Programmierer:innen können Funktionen im Umfang von bis zu einer halben Seite (bis maximal eine Seite) gut erfassen.
  - Hilfreich ist ein klarer Einstieg ins Programm mit einer sehr kurzen, übersichtlichen Startroutine.

    #pysrc_with_ok("1a/shortmain-snippet.py")

  ]

}
