#import "../style/template.typ": *

#let inputvalidation( selected_lang: "en" ) = {
if selected_lang == "en" [

== Input Validation
- Solution A Using
- Solution B Using
- Solution C Using

]else[

  == Eingabenüberprüfung

  #section_summary([
  Validierung des Inputs ist bei Benutzereingaben
 immer nötig, da den Eingaben von Usern prinzipiell nicht vertraut
 werden darf. *Never trust user data!*])

  #markup([Problem], [
    Bei der Verwendung von Funktionen wie _eval_, _exec_, oder _os.system_
    kann beliebiger Python Code ausgeführt werden. Dadurch ist die
    Verwendung auch extrem gefährlich!
  ])

    #pysrc_with_overlay("1d/no-snippet.py", [Please Improve])


  - *Lösung A Checks:* Jeden (User-)Input vor der Verwendung überprüfen

    Idealerweise "Whitelisting".

    #pysrc_with_ok("1d/validate-snippet.py")

  #pagebreak()
  - *Lösung B Keine gefährlichen Funktionen* verwenden, da den Input-Daten niemals vertraut werden kann.
    Es erscheint zwar besser #pykeyword([eval]) statt #pykeyword([exec]) zu verwenden, aber empfohlen wird gefährliche Funktionen - welche dynamisches Ausführen von beliebiegen Code ermöglichen - überhaupt gar nicht zu verwenden!

   Hier ein Beispiel mit explizitem Parsing durch Regular Expressions #english_term([regex]) und verrechnen der Daten mit den entsprechenden mathematischen Operationen (anstatt #pykeyword([eval])).  #english_term([Use regex])!
    #pysrc_with_ok("1d/switch-instead-eval-snippet.py")

   Erklärung zur #english_term([regex]) von oben (Ersatz für Zeile 8 aus dem oberen Listing):
    #pysrc_with_ok("1d/switch-instead-eval-re-snippet.py",start_with_number:8)

]

}
