#import "../style/template.typ": *

#let debug( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Logging and Debugging

  - Solution A Using


  ]else[

  == Debugging

  #section_summary([
    Zur Inspektion des Programmablaufes können mit einerseits einfache *#pykeyword([print]) Ausgaben* oder besser Ausgaben über einen *Logger* hilfreich sein. Im Zweifel ist aber der Einsatz eines *Debuggers* unumgänglich.
  ])

  #markup([Problem], [
    Der effektive Ablauf, der Flow durch das Programm kann leider im Source Code
    nicht immer gut und einfach ersichtlich sein.
  ])

  /*
  Um Sicherheit zu erlangen, in welcher Reihenfolge welche Funktionen durchlaufen werden, bzw. welche Zustände die Variablen aktuell im Programmfluss haben, kann man viele Ausgaben produzieren (Logging) oder Breakpoints setzen um ein Programm anzuhalten (*Debugging*).
*/

  - *Lösung A Print Statements:* Ausgabe von Log Informationen. Um den Ablauf eines Programmen nachzuvollziehen ist die Ausgabe von Statusinformationen hilfreich. #english_term([Use poor man's debugging])!

    #pysrc_with_ok("1e/debug-print-snippet.py")

  - *Lösung B Logging:* Umfangreiche Ausgaben mittels _Logger_. Bei vielen Outputs ist die Verwendung einer Logging Library empfehlenswert. Da kann man den Umfang der Ausgabe sehr gut über die Angabe eines *Log-Levels* wie `info`, `debug` oder `error` steuern.

    #pysrc_with_ok("1e/logger-snippet.py")


  - *Lösung C Debugger*: Zur gründlichen Analyse ist die Verwendung eines Debuggers noch viel mächtiger. Bei Live *debugging* kann nach jedem Ausführungsschritt der gesamte Programmstatus inspiziert werden. #english_term([Use breakpoints])!

    #table(
      columns: (53%,46%),
      inset: 0pt, column-gutter: 0.3cm, stroke: none,
      align: horizon,

      sourcecode(lang:"Bash",raw( read("../code/1e/debugger-snippet.sh") )),
      box( stroke: 1pt + gray,
        image("../images/debug.png")
      )
    )
  ]
}
