#import "../style/template.typ": *
#import "2a-git.typ": *
#import "2b-venv-libs.typ": *
#import "2c-testing-and-tools.typ": *
#import "2d-project-structure.typ": *

// Day 2:

#let intro( selected_lang: "en" ) = {
  if selected_lang == "en" [
    = Maintaining growing source base (Managing Software)
  ]else [

  = Softwareprojekte

  #v(0.5cm)

  Folgende Strategien helfen um gemeinsam im Team größere Softwareprojekte mit guter Qualität zu schreiben: Distributed Code Repository Git, Virtual Environments, Automated Testing und der Einsatz von externen Formatierung-, Linter- und Security- Tools.

  - (2a) Das Verwenden eines *Source Code Repository* garantiert Nachvollziehbarkeit und ermöglicht verteilte Zusammenarbeit im Entwicklungsteam. Abgesehen von "Gratis-Backups" ermöglicht Git weiters die Entwicklung in Branches, zum Beispiel für _development spikes_. Use #english_term([distributed code repo Git. Develop in feature branches])!

  - (2b) *Virtuelle Umgebungen* (venv) ermöglichen es externe Libraries zu verwenden,  verhindern dabei aber Versionskonflikte.  #english_term([Use virtual environments])!

  /*  treten je nach installiertem Betriebsystem und installierter Software bei Entwickler:innen auf. Sind Voraussetzungen — wie zum Beispiel nötige Pakete — erfüllt, oder muss ein Administrator diese vorweg erst installieren? Einfrieren der Versionen und / oder Bereitstellen von virtuellen Umgebungen ("virtual environments") machen das Leben leichte.*/

  - (2c) *Automatisiert Testen* ist nötig, damit sich neue Entwickler:innen überhaupt erst getrauen Änderungen an der Software durchzuführen. #english_term([Use  unit tests. Test driven development])!

  /*Das Team wächst und auch das Anlernen neuer Kolleg:innen ist angesagt. Plötzlich ist  Dokumentation gefordert. Gut ist die Dokumentation mit Testfällen zu ergänzen und beim Weiterentwickeln der Software mit dem Schreiben von Testfällen zu starten.*/

  - (2d) *Check-Tools* für das Format, die Struktur und die Security erhöhen die Qualität und die Sicherheit des Source Codes. #english_term([Use a formatter and linter])!
  /*Die Herausforderungen bezüglich der Sicherheit steigen an. Auch gute Code Qualität ist eine der Voraussetzungen an Sicherheit. Verwenden Sie Security-Check-Tools (beispielsweise _linter_ wie #link("https://github.com/pylint-dev/pylint",[Pylint]), um die Software anhand von Metriken zu bewerten.*/

  #v(0.5cm)
  Oft erweist sich ein kleines Skript als sehr nützlich und soll dann um neue Funktionalitäten erweitert werden. Software wächst. Nun steht man vor neuen Herausforderungen:

  - *Die Struktur* für ein größeres Softwaresystem unterscheidet sich drastisch von einem simplen Skript. Vor dem Wachsen ist es nötig eine Struktur zu finden die Erweiterungen gut zulässt. Die Frage der Art der Strukturierung -- nach Funktionalität, als Komponente, in Schichten -- ist nicht immer eindeutig und leicht zu beantworten. #english_term([Structure by modules, layers, components])!




  ]

  /*
  todo([Vorschau],
  [
    - Projektstruktur für größere Projekte
    - Code aus anderen Quellen (Libraries, Biblio, Internet, ChatGPT)

  ]
  */

// 2a
pagebreak()
git(selected_lang:selected_lang)


// 2b
pagebreak()
venv-libs(selected_lang:selected_lang)


// 2c
pagebreak()
testing_and_tools(selected_lang: selected_lang)


// 2d
pagebreak()
structure(selected_lang:selected_lang)


}
