#import "../style/template.typ": *

#let git( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Managing source (Git)

  - Solution A Using

  ]else[

  == Code Repository <git>

  #section_summary([
    Source Code Verwaltung mit Git gibt Sicherheit durch *Backup* am Server und ermöglicht
    nachvollziehbare *Zusammenarbeit* unter Entwickler:innen
  ])

  #markup([Problem], [
    Anfangs denkt man, kleine Skripts werde man eh nur selbst verwenden.
    Aber oft wächst der Umfang und die Funktionalität der Software.
    Dann kommt auch noch jemand und meint, diese Lösung würde man gerne ebenfalls einsetzen
    oder sogar weiterentwickeln.
  ])

  - *Lösung: Source Code Verwaltung mit Git*

  - Schritt A: Über die Web-Oberfläche ein neues Repository *Repo anlegen* und aus der Weboberfläche die URL zum #english_term([clonen]) des Repositories (für Schritt B) kopieren.

  - Schritt B: Lokal am Rechner eine vollständige *Kopie* des Repos mittels `git clone` erstellen.

    #bash("2a/git_clone.sh")// git clone git@mode.fh-joanneum.at:secure-code/workshop.git

    Hinweis: Im Dateisystem werden alle (nicht leeren) Unterverzeichnisse und Dateien angelegt. Die Metadaten (vorige Versionen der Dateien, URL des Git Servers usw.) finden sich im versteckten Verzeichnis `.git/`.


  - Schritt C: Verzeichnisse und Dateien von der Source Code Verwaltung durch Erstellen einer Datei mit Namen `.gitignore` *ausnehmen*. Zum Beispiel um das 'tmp' Verzeichnis auszunehmen:

    #bash("2a/create_gitignore.sh")

    #textsrc("2a/gitignore.txt", title: ".gitignore")

    Bzw. Dateien zum Repository mit `git add` *hinzufügen*.

    #bash("2a/git_add.sh")// git add .

  - Schritt D: Änderungen an den Dateien durchführen, diese mit `status` (optional auch mit `diff`) prüfen. Danach können die Änderungen mit `commit` übernommen werden. Dabei wird ein -- die Änderung erklärender -- Kommentar angegeben:

    #bash("2a/git_status.sh")// git status

    Den Grund bzw. Inhalt der Änderung durch eine so genannte *commit message* beschreiben. Diese ist dann jederzeit im *log* sichtbar:

    #bash("2a/git_commit.sh")// git commit -am "Fixed typo in README.md"

  #pagebreak()

  - Schritt E: Das Aufrufen von `pull` nicht vergessen um alle zwischenzeitlichen Änderungen am Source durch andere Personen vom Git Repository zu übernehmen. Dann erst weiter arbeiten mit Schritt B.

   #bash("2a/git_pull.sh")// git pull

  - Schritt F: Abschließend (oder auch gerne Zwischendurch) die eigenen Änderungen mit `push` auf den Server übertragen, zu #english_term([pushen]).

   #bash("2a/git_push.sh")// git push

  #v(1cm)

  *Weitere Empfehlungen:*



  - Automatische Anmeldung auf Servern (hier am Git Repository) durch SSH mit Schlüsselaustausch. Dazu wird zuerst ein *SSH Key Pair* erstellt (ohne #english_term([passphrase])).

    #bash("2a/keygen.sh") // ssh-keygen -t ed25519 -f ~/.ssh/key-for-git

    Den _public key_ ausgeben und den Plain Text mit Copy/Paste über das Web Interface am Server hinterlegen.

    #bash("2a/cat_public_key.sh") // cat ~/.ssh/key-for-git.pub

    Wenn nicht der Standard Name des Schlüsselpaares (wie `id_rsa` oder `id_ed25519`) verwendet wird, dann kann in der Datei `~/.ssh/config` konfiguriert werden, für welchen Server welche Keys verwendet werden sollen. Beispielsweise:

      #textsrc("2a/ssh_config.txt",title:"~/.ssh/config")

  - Änderungen ohne zu speichern zu *verwerfen* funktioniert mit `git stash`. Log information kann mit `git log --oneline` sehr kompakt betrachtet werden.

  - Änderungen an den Dateien mittels `git diff` oder in einer IDE  betrachten. In modernen IDEs können auch *Konflikte* interaktiv aufgelöst werden. #english_term([Solve merge conflicts])!

  - Für Zusammenarbeit in (verteilten) Teams empfiehlt es sich, sich über Entwicklung in *Feature Branches* zu informieren. #english_term([Select your branching strategy])!

  ]
}
