#import "../style/template.typ": *

#let venv-libs( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Using foreign code (Libraries, Biblio, Internet, ChatGPT)

  - Solution A Using

  - Solution B Using

  - Solution C Using

  - Solution D Using

  ]else[

  == Bibliotheken

 #section_summary([
   Bibliotheken (*Libraries*) ersparen viel Code selbst zu schreiben. Die Installation
   sollte bezüglich verwenderter *Versionen* transparent und nachvollziehbar sein.
 ])


  #markup([Problem], [
     Um Code aus anderen Quellen wie Bibliotheken (Libraries) zu verwenden,
     müssen diese lokal installiert werden.
  ])

  - *Schritt A: Python Virtual Environment erstellen*. Hier wird zum Beispiel ein verstecktes Verzeichnis `.venv` angelegt, um dort später Libraries zu installieren.

    #bash("2b/create_venv.sh") // python3 -m venv .venv

  - *Schritt B: Environment aktivieren*.

    - Unter Linux/Mac mit `source .venv/bin/activate`.

      #bash("2b/activate_venv_linux.sh") // source .venv/bin/activate

    - Bzw. unter Windows mit `.venv\Scripts\activate`.

      #bash("2b/activate_venv_win.sh") // .\.venv\Scripts\activate

  - *Schritt C: Bibliotheken installieren*.  In der Datei `requirements.txt` werden benötigte Libraries gelistet.

    #textsrc("2b/requrirements.txt", title: "requirements.txt")


    Bei aktivem Python Virtual Environment werden die Bibliotheken lokal ins Verzeichnis `.venv` installiert.

      #bash("2b/pip_install.sh") // pip install -r ./requirements.txt

  - Schritt D: Libraries kann man im Python Skript durch ein #pykeyword([import]) Statement verwenden.

    #pysrc_with_ok("2b/use_libraries-snippet.py") // import requests

  - Schritt E: Schlussendlich kann man das Python Virtual Environment durch `deactivate` verlassen.

    #bash("2b/deactivate_venv.sh"
    ) //deactivate

  ]
}
