#import "../style/template.typ": *

#let testing_and_tools( selected_lang: "en" ) = {
if selected_lang == "en" [

== Testing and Tools (Linter, Code Formatter)
- Solution A Using
- Solution B Using
- Solution C Using

]else[

  == Code Qualität

  #section_summary([
    Automatisiertes *Testen* und die Verwendung von Checker-Tools wie *Linter* oder Formatter
    erhöhen die Lesbarkeit, Sicherheit und Qualität von Programmen enorm.
  ])

  #markup([Problem], [
    Wenn man sich nicht sicher sein kann, dass Code nach Änderungen weiterhin
    noch wie gewollt funktioniert, getraut man sich nicht Code abzuändern.
    Je nach Stil und Entwicklungsumgebung erstellen Entwickler:innen unterschiedlich
    aussehenden Code, welcher dadurch schwerer zu lesen und warten ist.
  ])

  #pysrc_with_overlay("2c/no.py", [Please Improve])

  - *Lösung A: Automatisiertes Testen*#footnote([
      #link("https://docs.python.org/3/library/unittest.html")]
    ). #english_term([Use unit testing])!

    - Source code so gestalten, dass er einfach testbar ist:

      #pysrc_with_ok("2c/testable_code_snippet.py", title: "pretty.py")

    - Testfälle bereitstellen

      #pysrc_with_ok("2c/rununittests_snippet.py")


    #bash("2c/runtests.sh") // python3 -m unittest unittests4solution.py


  - *Lösung B: Source Code formatieren* #english_term([formatter]) bzw. Code *überprüfuen* #english_term([linter])

    #bash("2c/ruff_format_and_check.sh")
    //#bash("2c/ruff_format.sh") // ruff format solution.py
    //#bash("2c/ruff_check.sh") // ruff check solution.py
]

}
