#import "../style/template.typ": *

#let structure( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Project Structure for larger projects

  - Solution A Using

  - Solution B Using

  - Solution C Using

  - Solution D Using

  ]else[

  == Projektstruktur

  #section_summary([
    Die *Projektstruktur* für größere Projekte soll logisch gut aufgeteilt sein,
    damit sich Programmierer:innen schnell zurechtfinden.
    Typischerweise kann die Modularisierung nach *Funktionalität*,
    in *Schichten* oder nach *Komponenten* vorgenommen werden. #english_term([Structure in layers, components, or features])!
  ])

  #markup([Problem], [
    Wenn Skripts/Programme anwachsen kommt der Punkt, wo diese schwer lesbar werden.
    Leichtes Verständnis, Erweiterbarkeit und Wartbarkeit sind nicht mehr gegeben.
  ])

  - *Lösung A: Objektorientierte Programmierung (OOP)* vorziehen. Komplexe Aufgabenstellungen lassen sich durch _Klassen_ modellieren und der Code ist leichter verständlich bzw. besser test- und wartbar.

  - *Lösung B: Einstiegspunkt* festlegen. Durch das Überprüfen auf `__main__` wird Code nur beim direkten Start des Skripts aufgerufen. Beim Testen und bei der Verwendung als Library wird Code aber nicht unabsichtlich aufgerufen.

    #pysrc_with_ok("2d/check_if_main.py") //  __name__ == "__main__":


  - *Lösung C: Eigene Packages* erstellen. Unterverzeichnisse kann man als *Packages* strukturieren.

    - Zum Beispiel im Unterverzeichnis `dv` die Datei `vis.py` anlegen.

      #pysrc_with_ok("2d/class_in_lib.py",title: "dv/vis.py") // class DataVisualisation():


    - Die eigenen *Packages* können dann im restlichen Code mittels #pykeyword([import]) verwenden werden.

      #pysrc_with_ok("2d/use_custom_lib.py") // from dv.vis import DataVisualsation


  - *Lösung D: Typsicher programmieren*. Mit #english_term([type hints]) kann die IDE (PyCharm, VSCode) den Typ der Übergabe- und Rückgabeparameter überprüfen und beim Schreiben Hinweise geben. Zum Beispiel kann angezeigt werden, welche Parameter mit welchem Typ an eine Methode übergeben werden muss.

    #pysrc_with_ok("2d/type-hints-snippet.py")

  ]
}
