#import "../style/template.typ": *
#import "3a-client-server-communication.typ": *
#import "3b-webservices.typ": *
#import "3c-server.typ": *
#import "3d-excel.typ": *
#import "3e-dataanalytics.typ": *

#let intro( selected_lang: "en" ) = {
  if selected_lang == "en" [
    = Selected Topics /*(Dataanalytics, Server, Services)*/

    Providing and consuming web services.
  ]else [

    = Ausgewählte Lösungen
    /*Ausgewähltes (Netzwerk, Server, Services und Datenanalyse)*/


  #v(0.5cm)


  *Spezialthemen*


  #v(0.2cm)
  Das Bereitstellen eigener Daten als *ReSTful Web Service* ist für Systeme relevant, wo unterschiedlichste Clients die Informationen zentral abrufen wollen. Das API Design für Webserver/Webservices erfordert gute Dokumentation, und umfasst bei der Implementierung das Prüfen der Daten bezüglich Struktur, Datentyp und Wertebereich. In der Planung muss auf zukünftige Änderungen einer API durch Vergabe von API-Versionsnummern Rücksicht genommen werden.

  - (3a) Client- Server Kommunikation

  - (3b) WebServices

  - (3c) Ein eigener Server


  #v(0.3cm)

  Datenmanagment, *Datenanalyse und -visualisierung*. #english_term([Data processing]) bedeutet Daten anhand einer #english_term([pipeline]) abzuarbeiten. Daten werden eingelesen, bereinigt und verarbeitet, um schließlich als Grafiken exportiert zu werden. Zur Interpretation von Daten ist #english_term([visualisation]) nützlich: Grafische Aufbereitung erleichtert die Analyse und Interpretation der Daten. Zum besseren Verständnis von großen Daten eignet sich aber auch #english_term([interactive exploration]).

  - (3d) Datenmanagment mit Excel

  - (3e) Datenanalysen und Datenvisualisierung

  /*
  - (3f) Machine Learning: Trainieren von Modellen.
  */


  #v(2fr)
 *Generelle Anmerkungen bezüglich Security* bei der Softwareentwicklung: Algorithmen bezüglich Kryptografie und Security dürfen keineswegs selbst implementiert werden. Die wenigsten Entwickler:innen haben das theoretische und praktische Backgroundwissen um Aspekte wie _random_, _hashing_, _encrypt/decrypt_ oder _certificates_ selbst auf eine "kryptografisch sichere"(!) Art zu implementieren. #english_term([Use well tested, reliable and proven cryptographic libraries])!

  ]


pagebreak()


// 3a about client (tokens)
clientserver(selected_lang:selected_lang)

// 3b example GitLab web service
pagebreak()
webservices(selected_lang:selected_lang)

// 3c custom server
pagebreak()
server(selected_lang:selected_lang)

// 3b Datamanagement with (csv and) Excel
pagebreak()
excel(selected_lang:selected_lang)

// 3e Special Topic (Data Visualisation)
pagebreak()
dataanalytics(selected_lang:selected_lang)

// 3f Machine Learning (train your model)
// TODO
//
}
