#import "../style/template.typ": *
#import "3a1-credentials.typ": *
#import "3a2-communication.typ": *

#let clientserver( selected_lang: "en" ) = {
  if selected_lang == "en" [

    == Client-Server Communication

  ]else[

    == Client-Server Kommunikation

    // #ref(target: "neverhardcode") or @neverhardcode
    Wie schon im Abschnitt über Passwörter angeführt, dürfen sensible Daten nie im Source Code hardcodiert gespeichert werden. Clients benötigen für die Anmeldung am Server aber genau solche sensible Daten wie Zugangsdaten (_z.B. Benutzername+Passwort_). Verschiedene Arten der Anmeldung sind möglich.
  ]

  // 3a1 Server Authentication
  credentials(selected_lang:selected_lang)

  // 3a2 Communication
  communication(selected_lang:selected_lang)


/*
Software verarbeitet Daten. Diese werden aus dem Internet, von der Cloud, von (mehreren) Webservices, sogenannten _web service endpoints_ bezogen.

- *Zugangsdaten* (_credentials_ wie Benutzername und Passwort, Tokens, API-Keys, SSH-Keys) müssen von Applikationen an die Web-Services gesendet werden, damit die autorisierte Abfrage von Informationen klappt. Die Zugangsdaten dürfen auch keinesfalls im Code Repository verwaltet werden, daher werden entsprechende lokale Konfigurationen mit `.gitignore` von Git ausgenommen. Bei CI/CD werden credentials oftmals als Environment Variable gesetzt um nicht im Source zu landen.

- *Sichere Übertragung* ist durch TLS (Transport Layer Security) normal immer gegeben, aber (mobile) Netzwerke für sich sind fallweise langsam, instabil und unzuverlässig. Daher sollte man *Fehler im Netzwerk* als normal erachten, erwarten und entsprechend durch Programmlogik behandeln. Client Software muss mit unterschiedlichsten Fehlern (z.B. Service temporär nicht erreichbar) umgehen können. Lokales Caching und wiederholte Synchronisationsversuche ermöglichen den Usern die Software auch offline zu nutzen.

#v(0.2cm)
*/

}
