#import "../style/template.typ": *

#let credentials( selected_lang: "en" ) = {
  if selected_lang == "en" [

  === Handling sensitive data (credentials)

  - Solution A Using

  - Solution B Using

  - Solution C Using

  - Solution D Using

  ]else[

  === Anmelden am Server (Authentication)

  #section_summary([
    Zur Anmeldung an Netzwerkdiensten sollten bevorzugt *Tokens* verwendet werden. Im Speziellen sind *username/password* besser interaktiv einzugeben.
    *API-tokens* werden nur lokal am Rechner hinterlegt und nicht ins Git Repository gespeichert.
    Bei sicherheitskritischen Anwendungen ist eine *multi-faktor-authentication* unumgänglich.
  ])

  #markup([Problem], [
    Wenn Skripts Daten von einem Server holen
    oder an ein Web-Service Endpoint senden, dann ist meist eine Anmeldung nötig.
  ])

  Unterschiedliche Arten der Anmeldung sind möglich.

  - *Lösung A: Username und Passwort*

    - Vorteil: Einfach.
    - Nachteil: es müssen die Passwörter im Klartext bereitgestellt werden.

  - *Lösung B: API Tokens*

    - Vorteil: Kein Passwort nötig. Vom (random) Token kann nicht auf ein ursprüngliches Passwort zurückgeschlossen werden. Bei Bedarf ist ein Entziehen der Zugriffserlaubnis in modernen Systemen recht einfach.
    - Nachteil: One-time Tokens sind fallweise aufwendig in der Umsetzung.

  - *Lösung C: SSH Autorisierung*

    - Vorteil: Maschine-zu-Maschine Kommunikation ist bequem.
    - Nachteil: Eine _public key infrastructure_ ist nötig.

  - *Lösung D: Autorisierung mittels mehreren Faktoren*

    - Vorteil: Sehr sicher, da neben einem Passwort (sogar mehrere) weitere Faktoren (z.B. biometrischer Fingerabdruck, SMS-Bestätigung) nötig sind.
    - Nachteil: In der Umsetzung sehr aufwendig.


  *Dringende Empfehlungen:*

  - Credentials (wie Username und Passwort, API-Tokens, SSH-Keys) niemals im Source Code hardcodiert hinterlegen.
  - Konfigurationsdateien mit sensitiver Information immer mittels `.gitignore` vom Git Source Code Management ausnehmen.

  ]
}
