#import "../style/template.typ": *

#let communication( selected_lang: "en" ) = {
  if selected_lang == "en" [

  === Client Server Communication

  - Solution A Using


  ]else[

  === Kommunikation mit einem Server

  #section_summary([
      Bei der Übertragung von Anmeldedaten sind *POST Requests* den GET requests vorzuziehen,
      da POST Daten nicht als Bookmarks oder in Log-files landen.
      Tokens werden im *Header* mitgesendet. Typerscherweise handelt es sich um ReST Aufrufe und die Daten werden als JSON übertragen.
  ])

  #markup([Problem], [
    Clients senden sensitive Daten über das Netzwerk. Bei Anfragen (requests) mittels `GET` sind die Anmeldedaten direkt in der URL sichtbar und sensible Daten können dadurch auch in Log Files am Server landen.
  ])

  Über das HTTP-Protokoll können Daten als *`GET`* oder *`POST`* Parameter übertragen werden.
  Weiters ist es möglich Daten im `Body` oder auch direkt im `Header` zu übermitteln. Es ist besser auf `POST` (wie bei HTML-Formularen) Requests zurückzugreifen, da hier die Daten im Body -- und somit nicht Teil der URL -- übertragen werden. Beim Senden von Anmeldedaten via *Basic Authentication* oder
  via *Bearer*-Information werden die Daten im Header übermittelt.

  Import der nötigen Libraries.
  #sourcecode(
      lang:"Python",
      raw( read("../code/3a/client-libs-snippet.py") ))

  Festlegen von Variablen für Username, Passwort, API Keys usw.
  /* Je nach Anwendungsfall (zum Beipiel bei einer CI-Pipeline) kann es sich
  auch anbieten Username und Passwort aus Umgebungsvariablen zu verwenden. */
  #sourcecode(
      lang:"Python",
      raw( read("../code/3a/client-vars-snippet.py") ))
  Anfrage (_request_) absenden.
  #sourcecode(
      lang:"Python",
      raw( read("../code/3a/client-snippet.py") ))

  - *Lösung A GET* Nicht empfehlenswert, da sensible Anmeldedaten in die URL hinein kodiert sind und somit beim Bookmarken und in den Log-Files sichtbar werden.

    #sourcecode(
      lang:"Python",
      raw( read("../code/3a/get-snippet.py") ))

  - *Lösung B POST*: Senden von Daten im Body (via `POST`) und nicht in der URL.

    #sourcecode(
      lang:"Python",
      raw( read("../code/3a/post-snippet.py") ))

  #pagebreak()

  - *Lösung C: Basic Auth*: Bei Basic Authentication erfragt der Browser die Benutzerdaten (Username and Password) in einem Browser-spezifischen Eingabefenster.

    #sourcecode(
      lang:"Python",
      raw( read("../code/3a/basic-snippet.py") ))

  - *Lösung D: Bearer*: Im Header wird ein Token oder API key übertragen.

    #sourcecode(
      lang:"Python",
      raw( read("../code/3a/bearer-snippet.py") ))

  #v(0.5cm)

  *Weitere Empfehlungen:*

  Verbindungen müssen vertrauensvoll sein.

  - Eine verschlüsselte Verbindung  sollte standardmäßig verwendet werden. Auch Man-in-the-Middle (MitM) Attacken sind so viel schwerer durchzuführen. #english_term([Use https with Transport Layer Security; TLS])!

  - *Ende zu Ende Verschlüsselung*. Wenn hochsensible Daten übertragen werden, ist eine zusätzliche Verschlüsselung der Daten selbst nötig, denn am Ende einer sicheren Verbindung werden Daten typischerweise am Server entpackt und sind am Server (in der Datenbank, im Filesystem) wieder im Klartext lesbar. #english_term([Use end-to-end encryption])!

  ]
}
