#import "../style/template.typ": *

#let server( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Special topic: Creating a Simple Server

  - Solution A Using

  - Solution B Using

  - Solution C Using

  - Solution D Using

  ]else[

  == Implementierung Server

  #section_summary([
    Zur Bereitstellung von Daten im Netzwerk - als *Web-Service* -
    ist es üblich ein maschinenlesbares Format wie *JSON* zu verwenden.
  ])


  #markup([Problem], [
    Normale Webseiten sind zwar gut menschenlesaber, aber
    für automatisierte Verarbeitung schlecht geeignet.
  ])


  - Python3 Server mit #link("https://flask.palletsprojects.com/",[`Flask`]) Framework um ein (ReSTful) Web Service bereitzustellen.

    #pysrc_with_ok("3c/flask-snippet.py")

  - Definition eines API Aufrufs (web service enpoints) für das Web Service.

    #pysrc_with_ok("3c/api-snippet.py")

  - Typischerweise können mittels `ReSTful web services` Daten im JSON Format über definierte API Aufrufe von beliebigen Clients (JavaScript im Browser, mobile Apps, auf der Kommandoziele mit CURL) abgerufen werden.

   Beispielhafte Verwendung des Kommandzeilen Tools `curl`.

    #bash("3c/curl-snippet.sh")


  *Weitere Empfehlungen:*

  - Je nach Bedarf auch weitere Frameworks (#link("https://fastapi.tiangolo.com",[_FastAPI_]),...) in Erwägung ziehen.

  - Produktive Server über das Server-Team bereitstellen und die Server härten (*hardening*) lassen.


  /*
   *Hardening* von selbst verwalteten Servern ist nötig, wenn die entwickelten Web-Services nicht auf einer externen Cloud gehostet werden, wo Provider für eine sichere Umgebung und Updates sorgen.
   */


  ]
}
