#import "../style/template.typ": *

#let excel( selected_lang: "en" ) = {
  if selected_lang == "en" [

  == Manage Data with Excel

  - Solution A Using

  - Solution B Using

  - Solution C Using

  - Solution D Using

  ]else[

  == Excel

  #section_summary([
      Wenn gesammelte und verarbeitete Daten weitergegeben werden,
      dann bietet sich -- je nach Zielgruppe -- oftmals *Excel* an.
  ])

  #markup([Problem], [
    Viele Personen (z.B. im Management) wollen Daten interaktiv in Excel bearbeiten
    und Visualisieren. CSV -- #english_term([comma seperated value]) -- Dateien sind so einfach aufgebaut, dass man diese direkt, ohne die Verwendung von Libraries, erstellen kann. Allerdings ist das bald unflexibel, fehleranfällig und mühsam.
  ])

  #pysrc_with_overlay("3d/output2csv-snippet.py", [Please Improve])

- *Lösung*:

  - Eine Excel Datei (`*.xlsx`) kann mithilfe geeigneter Bibliotheken#footnote([
    OpenPyXL Dokumentation auf #link("https://openpyxl.readthedocs.io/").

  ]) erstellt werden.

  #table(
    columns: (50%,50%),
    inset: 0pt, column-gutter: 0.3cm, stroke: none,
    align: horizon,
    pysrc_with_ok("3d/output2excel-snippet.py"),
    box( stroke: 0pt + gray,
      align(center, [
        Ansicht in MS Excel:
        #image("../images/excel.png", fit: "contain", width: 95%)
         Es werden die Werte in Spalte D durch die Formel berechnet. Auch die Summenformel für das Feld D5 wurde in Python erstellt.])
    )
  )
  ]
}
