#import "../style/template.typ": *

#let visualise-data( selected_lang: "en" ) = {
  if selected_lang == "en" [

  === Data Processing Pipeline

  - Solution A:


  ]else[


  === Data processing pipeline

  #section_summary([
    Für automatisierte Analyse und -interpretation werden
    Schritt für Schritt Daten entlang einer *Visualisation Pipeline*
    aufbereitet und visualisiert.
  ])


  #markup([Problem], [
    Große Mengen an Daten sind oft schwer zu verstehen und zu interpretieren.
  ])

  In einer *Data processing pipeline* können Daten aufbereitet und visualisiert werden. Dazu sind typischerweise Libraries wie #link("https://pandas.pydata.org",[Pandas]), #link("https://matplotlib.org",[Matplotlib]) oder #link("https://seaborn.pydata.org",[Seaborn]) nötig.

    #pysrc_with_ok("3e/data-visualisation-0-libs-snippet.py")

  - *Schritt A: Daten einlesen* und im Speicher verwalten. #english_term([Data Frames])

    #pysrc_with_ok("3e/data-visualisation-1-read-snippet.py")

  - *Schritt B: Filtern:* Man verwendet Befehle wie `info()` oder `head(40)` für das Inspizieren und Filtern der Daten.

    #pysrc_with_ok("3e/data-visualisation-2-dataframe-snippet.py")

  - *Schritt C: Korrekturen vornehmen:* Die Daten durch Ergänzen, Entfernen, Korrekturen bereinigen. Hier ein Beispiel um 4-stellige Zahlen im Text der Spalte "title" zu finden und als neue Spalte "year" zu übernehmen. #english_term([data cleansing])

    #pysrc_with_ok("3e/data-visualisation-3-repair-snippet.py")

  - *Schritt D: Berechnungen*: Nützliche Werte wie Summen können über die Daten berechnent werden.

    #pysrc_with_ok("3e/data-visualisation-4-crunch-snippet.py")

  - *Schritt E: Visualisierungen:* Daten werden für besseres Verständnis als Grafiken visualisiert und die Plots ("figures") abspeichern.

    #pysrc_with_ok("3e/data-visualisation-5-visualise-snippet.py")


    /*#v(0.5cm)

  *Weitere Empfehlungen:*

  - Verschiedene *Visualisierungs Bibliotheken* (für Plots, Bilder) probieren.
  - Weiterverarbeitung bzw. Verwendung im Marketing (manuelles Aufbereiten) kann durch *Excel-Export* erreicht werden. Dazu eventuell auch den Umfang der Daten reduzieren.
*/
  ]
}
