#import "../style/template.typ": *
#import "appendix-a-styleguide.typ": *
#import "appendix-b-cheatsheet.typ": *
#import "appendix-c-security.typ": *

// Day 1: Coding / Python Basics

#let appendix( selected_lang: "en" ) = {
  if selected_lang == "en" [

    = Appendix

  ]else [

  = Anhang

  #v(0.5cm)
  Welche Ressourcen nutzen Python Entwickler:innen typischerweise? Neben Stackoverflow, ChatGPT und CoPilot wird empfohlen, die originalen Dokumentationen, Community Styleguides aber auch Cheatsheets zu verwenden.


  /*
  #v(0.5cm)
  Was macht meinen Code noch sicherer?

  - *Security Toos* sind zusätzlich zu normalen Testfällen extrem nützlich. Sie können automatisiert (in der CI/CD Pipeline) aufgerufen werden um die Qualität und Sicherheit von Code zu überprüfen. Einfachst Tools sind sogenannte *linter* wie _Pylint_.
  */

  ]

counter(heading).update(0)
set heading(numbering: none)





v(0.6cm)
styleguide(selected_lang:selected_lang)

v(0.6cm)
cheatsheet(selected_lang:selected_lang)
// security(selected_lang:selected_lang)

v(1cm)
if selected_lang == "en" [

  *Source Code*: Find the source code at #link("https://mode.fh-joanneum.at/secure-code/workshop/").

  ]else [
  *Source Code*: Die vollständigen Python Skripts zu den in diesem Dokument präsentierten Code Snippets findet sich unter #link("https://mode.fh-joanneum.at/secure-code/workshop/"). Happy Coding!
]

}
