#import "../style/template.typ": *

#let intro( selected_lang: "en") = {

set heading(numbering: none)

if selected_lang == "en" [
= Intro
How to make fun out of coding?

]else[
= Einleitung

#v(0.5cm)

Die zentrale Frage ist: *Wann und wie macht Coden Spaß?* Dazu ist gut zu wissen: Programmierer:innen lieben effizient und selbstbestimmt zu arbeiten.

+ Sie wollen sich bei typischen Problemen schnell und effektiv *selbst helfen* können. Das verleiht Sicherheit, bereitet Freude und macht Lust auf mehr.

+ Sie pflegen *produktive Faulheit*, indem sie sich wiederholende Abläufe automatisieren.

+ Sie wollen aber auch nicht unbedingt alles neu selbst erfinden. So nutzen sie *existierenden Code* von Libraries, Packages oder Code-Snippets.

+ Sie stellen an sich den Anspruch Code zu *verstehen* bevor sie ihn weiterverwenden.

+ Selbst bei kleineren Aufgaben ist *Lesbarkeit und Wartbarkeit* von Code für Programmierer:innen immer ein wichtiges Thema.

+ Sie *lieben Fehler* die sie machen. Warum? Weil sie auftretende Fehler selbst beheben können, da die Python Fehlermeldungen leicht zu verstehen, hilfreich und konstruktiv sind.

+ Sie entwickeln Software *in kleinen Schritten*. Das bringt viele Erfolgserlebnisse und verringert ganz nebenbei die Gefahr von #english_term([Overengineering]).

+ Sie wissen, dass für Skripts oft *wenige Zeilen Code genügen*. Sie nutzen umfangreichere Modellierung und objektorientierte Programmierung (OOP) erst bei größeren Projekten.

+ Je nach vorliegendem Problem greifen sie auf unterschiedliche Konzepte der Programmierung zurück. Zum Beispiel auf auf deklarative Programmierung beim Pattern-Matching mit regulären Ausdrucken #english_term([regex]) und auf funktionale Programmierung mit #english_term([Thinking in Lists]) bei umfangreichen textuellen Eingabedaten.

+ Sie legen auch Wert auf *Performance* und optimieren bzw. parallelisieren *bei Bedarf*.


#v(0.1cm)
*Zum Aufbau des Workshops*

Im Workshop wird #english_term([hands-on]) gearbeitet. Im ersten Schritt versucht man als Teilnehmer:in existierenden Code zu *lesen*. Da der vorgestellte Code nicht optimal und teilweise  fehlerhaft ist, stellt man Vermutungen über Probleme und deren Auswirkungen auf. Dann werden gemeinsam *Lösungen diskutiert* und Alternativen bewertet. Eine mögliche Lösung wird *ausprogrammiert*.

_Hinweis:_ Fehler sind wertvoll! Fehler sind produktiv! Eine Empfehlung lautet, während des Workshops möglichst viele unterschiedliche Fehler zu machen. Aber anstatt schnell Anpassungen "auf Verdacht" vorzunehmen, versucht man *zuerst* die Fehlermeldungen im Kontext zu verstehen und erst *daraufhin* zu beheben. Dadurch kann der größtmögliche Lerneffekt erzielt werden. Erfahrungsgemäß sinkt dadurch die Zeit für die Fehlerbehandlung dramatisch.
]
}
body
