#import "../style/template.typ": *
// Intro
#import "intro.typ": *
// Day 1: Coding / Python Basics
#import "1-intro.typ": intro as s1_intro

// Day 2: Larger Projects
#import "2-intro.typ": intro as s2_intro

// Day 3: Network / Webservice / Client / Server
#import "3-intro.typ": intro as s3_intro

// Appendix
#import "appendix.typ": *

// Overall structure of the document:
#let main( selected_lang: none ) = [

#let now() = {
  set text(lang: "de")
  let today = datetime.today()
  [#today.display("[month repr:long] [day padding:none], [year] ")]
}
// frontpage
#show: handout.with(
  date: [Printed #now()], // [Printed February 3, 2025],
  selected_lang: selected_lang,
)


#set heading( numbering: "1.a.1" )

// intro
#pagebreak()
#intro(selected_lang:selected_lang)


// Day 1: Coding / Python Basics
#pagebreak()
#s1_intro(selected_lang:selected_lang)


// Day 2: Larger Projects
#pagebreak()
#s2_intro(selected_lang:selected_lang)


// Day 3: Network / Webservice / Client / Server
#pagebreak()
#s3_intro(selected_lang:selected_lang)

#set heading(numbering: none)

// Appendix
#pagebreak()
#appendix(selected_lang:selected_lang)

]
